function [time_THM,TT_THM,depth_THM, T_ice_THM]= LoadCENTHMData()
opts = delimitedTextImportOptions("NumVariables", 28);
opts.DataLines = [1, Inf];
opts.Delimiter = ",";
opts.VariableNames = {'time', 'IceTemperature_0m',	...
    'IceTemperature_2m',	'IceTemperature_4m',	'IceTemperature_6m',...
    'IceTemperature_8m',	'IceTemperature_10m',	'IceTemperature_12m',...
    'IceTemperature_14m',	'IceTemperature_16m',	'IceTemperature_18m',...
    'IceTemperature_21m',	'IceTemperature_24m',	'IceTemperature_27m',...
    'IceTemperature_30m',	'IceTemperature_33m',	'IceTemperature_36m',...
    'IceTemperature_39m',	'IceTemperature_42m',	'IceTemperature_45m',...
    'IceTemperature_48m',	'IceTemperature_53m',	'IceTemperature_58m',...
    'IceTemperature_63m',	'IceTemperature_68m',	'IceTemperature_73m',...
    'battery_voltage' 'logger_temperature'};
opts.VariableTypes = ["datetime", "double", "double", "double", "double",...
    "double", "double", "double", "double", "double", "double", "double",...
    "double", "double", "double", "double", "double", "double", "double",...
    "double", "double", "double", "double", "double", "double", "double",...
    "double", "double"];
opts = setvaropts(opts, 1, "InputFormat", "yyyy-MM-dd HH:mm:ss");
opts.ExtraColumnsRule = "ignore";
opts.EmptyLineRule = "read";
data_long = readtable("C:\Users\bav\OneDrive - Geological survey of Denmark and Greenland\Data\Camp Century\data_long.txt", opts);
clear opts
data_long=data_long(:,1:end-2);

opts = delimitedTextImportOptions("NumVariables", 26);
opts.DataLines = [1, Inf];
opts.Delimiter = ",";
opts.VariableNames = {'time', 'IceTemperature_0m','IceTemperature_1m',	...
    'IceTemperature_2m',	'IceTemperature_3m', 'IceTemperature_4m',...
    'IceTemperature_5m',    'IceTemperature_6m',    'IceTemperature_7m',...
    'IceTemperature_8m',	'IceTemperature_9m',   ...
    'IceTemperature_11m',   'IceTemperature_13m',...
    'IceTemperature_15m',	'IceTemperature_17m',...
    'IceTemperature_19m',	'IceTemperature_22m',	'IceTemperature_25m',...
    'IceTemperature_28m',	'IceTemperature_31m',	'IceTemperature_34m',...
    'IceTemperature_38m',	'IceTemperature_42m',	'IceTemperature_46m',...
    'IceTemperature_50m',	'IceTemperature_54m'};
opts.VariableTypes = ["datetime", "double", "double", "double", ...
    "double", "double", "double", "double", "double", "double", "double",...
    "double", "double", "double", "double", "double", "double", "double",...
    "double", "double", "double", "double", "double", "double", "double",...
    "double"];
opts = setvaropts(opts, 1, "InputFormat", "yyyy-MM-dd HH:mm:ss");
opts.ExtraColumnsRule = "ignore";
opts.EmptyLineRule = "read";
data_short = readtable("C:\Users\bav\OneDrive - Geological survey of Denmark and Greenland\Data\Camp Century\data_short.txt", opts);
clear opts
 
[~, ind] = sort(data_long.time);
data_long=data_long(ind,:);
[~, ind]= unique(data_long.time);
data_long=data_long(ind,:);
data_long.time=datenum(data_long.time);
data_long = ResampleTable(data_long);

data_short = [data_short(1,:); data_short];
for i =2:width(data_short)
    data_short.(data_short.Properties.VariableNames{i})(1) = NaN;
end
data_short.time(1) = datetime(data_long.time(1),'ConvertFrom','datenum') ;
[~, ind] = sort(data_short.time);
data_short=data_short(ind,:);
[~, ind]= unique(data_short.time);
data_short=data_short(ind,:);
data_short.time=datenum(data_short.time);
data_short = ResampleTable(data_short);

d_long = [0	2	4	6	8	10	12	14	16	18	21	24	27	30	33	36	39	42	45	48	53	58	63	68	73];
d_short = [0	1	2	3	4	5	6	7	8	9	11	13	15	17	19	22	25	28	31	34	38	42	46	50	54];

for i = 1:length(data_short.Properties.VariableNames)
    data_long.(strcat(data_short.Properties.VariableNames{i},'_2')) = ...
        data_short.(data_short.Properties.VariableNames{i});
end
data_long.time_2 = [];

% creating depth array
% Thermistors were deployed at depths
% short depth 0:9 11:2:19 22:3:38 42:4:54
% 0	1	2	3	4	5	6	7	8	9	11	13	15	17	19	22	25	28	31	34	38	42	46	50	54
% 
% long message = long string + battery voltage + logger temperature
% long depth 0	2	4	6	8	10	12	14	16	18	21	24	27	30	33	36	39	42	45	48	53	58	63	68	73
d = [0	2	4	6	8	10	12	14	16	18	21	24	27	30	33	36	39	42	45	48	53	58	63	68	73 ...
    0.01	1	2.01	3	4.01	5	6.01	7	8.01	9	11	13	15	17	19	22	25	28	31	34	38	42	46	50	54];

time_THM = data_long.time';
cc_extra = table2array(data_long(:,2:end))';
depth_THM =  repmat(d',...
    1,length(time_THM));
[depth_THM, I] = sort(depth_THM,1);
J = repmat(1:length(data_long.time),size(I,1),1);
ind_sorted = sub2ind(size(I),I(:),J(:));
T_ice_THM = reshape(cc_extra(ind_sorted),size(I));
% removing the first measured temperatures
T_ice_THM(:,1:72) = NaN;
TT_THM = repmat(time_THM,size(cc_extra,1),1);
clearvars J ind_sorted cc_extra data_long data_short d  d_long d_short ind opts
figure
step  = 72;
col = PlotTemp(TT_THM(:,(1:step:end)),...
    depth_THM(:, (1:step:end)),...
    T_ice_THM(:, (1:step:end)),...
    'PlotTherm', 'yes',...
    'PlotIsoTherm', 'no',...
    'ShowLegend','no',...
    'cmap','jet',...
    'Interp','on',...
    'XLabel','',...
    'YLabel',' ',...
    'CLabel','Firn temperature (^oC)',...
    'Range', -40:1:0,...
    'FlatSurface','no'); 
title('CEN_THM')
end