function []=WritingModelOutput(time,data_surf,depth_act, data_subsurf,j,  c)
    % Surface variables
    namefilesurf = sprintf('%s/surf-bin-%i.nc',c.OutputFolder,j);
       
    varname =  {'Year'  'Day'   'Hour' ...
        'LRin' 'LRout_mdl' 'SHF' 'LHF' 'GF' 'rainHF' 'meltflux'...
        'H_surf' 'SMB_mweq' 'melt_mweq' 'sublimation_mweq' ...
        'H_comp' 'runoff' 'snowthick'...
        'snowfall' 'rainfall' 'SRin','SRout', 'Tsurf' 'H_T','snowbkt',...
        'theta_2m','RH_2m_wrtw','ws_10m'};
    
    unit =  {'yr' 'd' 'h'...
        'Wm-2' 'Wm-2' 'Wm-2' 'Wm-2' 'Wm-2' 'Wm-2' 'Wm-2'...
        'm' 'm_weq' 'm_weq' 'm_weq' 'm' 'm_weq' 'm'...
        'm_weq' 'm_weq' 'Wm-2' 'Wm-2' 'K' 'm', 'm_weq',...
        'K','%','ms-1'};
    
    long_varname =  {'Year'  'Day of the year'   'HourUTC' ...
        'Downward longwave radiation flux'...
        'Calculated upward longwave radiation flux'...
        'Sensible heat flux' 'Latent heat flux' ...
        'Heat flux from the subsurface to the surface' ...
         'Heat flux from rain' ...
         'Melt energy'...
        'Surface height above model lower boundary at start in meters'...
        'Surface mass balance water equivalent' ...
        'Melt per time step in water equivalent'...
        'Sublimation per time step'...
        'Cumulated compaction in meters' ...
        'Runoff per time step' ...
        'Snow thickness' ...
        'Snowfall per time step' ...
        'Rainfall per time step' ...
        'Incoming shortwave radiation' ...
        'Outgoing shortwave radiation' ...
        'Calculated surface temperature', ...
        'Height of temperature sensor', ...
        'Content of the snow bucket',...
        '2m temperature',...
        '2m relative humidity with regards to water',...
        '10 m wind speed'};
    
    WriteNC_1D(namefilesurf, time, data_surf, varname, unit, long_varname)
    clear data varname unit long_varname

    % Subsurface variables    

    varname =  {'T_ice' 'rho' 'slwc' 'snic' 'snowc' 'dgrain' 'rfrz' 'compaction'};
    unit =  {'C' 'kg/m^3' 'mweq' 'mweq' 'mweq' 'mweq' 'mm' 'm'};
    long_varname = {'Firn temperature',...
                    'Firn density excluding ice content',...
                    'Firn liquid water content',...
                    'Firn ice content',...
                    'Firn snow content',...
                    'Firn grain size',...
                    'Subsurface meltwater refreezing',...
                    'Firn compaction'};

    for ii = 1:length(data_subsurf)
        fprintf('Saving %s \n', varname{ii})
        tic
        WriteNC_2D(sprintf('%s/%s_bin_%i.nc',c.OutputFolder,varname{ii},j), ...
            time, depth_act, data_subsurf{ii}, 'Depth', 'm', ...
            'Depth below the initial surface position',...
            varname{ii}, unit{ii}, long_varname{ii});
        toc
    end
    
    if c.track_density
            % Subsurface variables
        namefilesubsurf = sprintf('%s/track_density.nc',c.OutputFolder);
        data = {density_avg_20};
        varname =  {'density_avg_20'};
        unit =  {'kg/m^3'};

        for i = 1:length(data)
            WriteNetCDF_old(namefilesubsurf, data{i}, varname{i}, c.M, 6, unit{i})
        end
        
        clear data varname unit
            % Subsurface variables
        namefilesubsurf = sprintf('%s/track_CC.nc',c.OutputFolder);
        data = {CC20};
        varname =  {'CC20'};
        unit =  {'kJ/m2'};

        for i = 1:length(data)
            WriteNetCDF_old(namefilesubsurf, data{i}, varname{i}, c.M, 6, unit{i})
        end
        clear data varname unit
    end
end