function [T_mod_out, T_diff, ME, RMSE, R2]=T_diff_plotting(TT_obs, depth_obs, T_ice_obs, ...
    depth_mod, Tsurf_mod, T_ice_mod, H_surf_mod, model_name, obs_name,...
    range,OutputFolder, vis)
%interpolating modelled at observed depth
    T_mod_out = zeros(size(depth_obs));
    ind_obs = find(nansum(~isnan(T_ice_obs),1)>1);
    for j = ind_obs
        T_mod_out(:,j) = ...
            ConvertToGivenDepthScale( [0; depth_mod(:,j)],...
            [Tsurf_mod(j); T_ice_mod(:,j)],...
            depth_obs(:,j),... 
            'linear');
    end
    
    T_diff = T_mod_out - T_ice_obs;
    ME = nanmean(T_diff(:));
    RMSE = sqrt(nanmean(T_diff(:).^2));
    lm = fitlm(T_mod_out(:), T_ice_obs(:));
    R2 = lm.Rsquared.Ordinary;
    Tsurf_diff = Tsurf_mod*NaN;

%     f = figure('Visible', vis);
%     f.OuterPosition = ([0.9 0.9 [21 29.7]-0.5]);
    col3 = PlotTemp(TT_obs(:,1:24:end),...
        depth_obs(:,1:24:end),...
        T_diff(:,1:24:end),...
        'PlotTherm', 'yes',...
        'PlotIsoTherm', 'no',...
        'ShowLegend','no',...
        'cmap','BWR_c',...
        'XLabel','Year',...
        'YLabel','Depth (m)',...
        'FlatSurface','no',...
        'CLabel',sprintf('%s - %s \n firn temperature (^o C)',model_name, obs_name),...
        'Range', range); 
    hold on

    col3.TickLength=col3.TickLength*5;

    for i = 1:length(col3.YTickLabel)
        if i/2~=floor(i/2)
            col3.YTickLabel(i,:)=' ';
        end
    end
    ind_nonan = find(nansum(~isnan(T_diff),1)>1);
    set_monthly_tick(TT_obs(1,ind_nonan));
    xlim(TT_obs(1,ind_nonan([1 end])))
    ylim([min(min(depth_obs(:,ind_nonan))) max(max(depth_obs(:,ind_nonan)))])
    set(gca,'XTickLabelRotation',0)
end